<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigEventoh extends Base\MigEventoh
{

    const DEFAULT_IDIMPRESEVENTO = 'S';
    const DEFAULT_IDEVENTO_DEMONS = 'N';
    const DEFAULT_ID_RETROC = 'SEMPRE';
    const DEFAULT_ID_ZERAEVENTO = 'N';
    const DEFAULT_IDMEDIA_EVENTO = 'N';
    const DEFAULT_IDFALTA_13 = 'N';

    /**
     * @param $nreventom
     * @return \Folha\Entities\MigEventoh
     */
    public function setNreventom ($nreventom) {
        $nreventom = \Importacao\Logic\Validacoes::verificaChaveMae('FPA_EVENTOM', 'NREVENTOM', ProjetoImportacao::getNrorg(), $nreventom);
        $this->nreventom = $nreventom;
    }

    /**
     * @param $idimpressevento
     * @return \Folha\Entities\MigEventoh
     */
    public function setIdimpressevento ($idimpressevento) {
        if (empty($idimpressevento)) {
            $idimpressevento = self::DEFAULT_IDIMPRESEVENTO;
        }
        $this->idimpressevento = $idimpressevento;
    }

    /**
     * @param $ideventodemonst
     * @return \Folha\Entities\MigEventoh
     */
    public function setIdeventodemonst ($ideventodemonst) {
        if (empty($ideventodemonst)) {
            $ideventodemonst = self::DEFAULT_IDEVENTO_DEMONS;
        }
        $this->ideventodemonst = $ideventodemonst;
    }

    /**
     * @param $idretrocedevent
     * @return \Folha\Entities\MigEventoh
     */
    public function setIdretrocedevent ($idretrocedevent) {
        if (empty($idretrocedevent)) {
            $idretrocedevent = self::DEFAULT_ID_RETROC;
        }
        $this->idretrocedevent = $idretrocedevent;
    }

    /**
     * @param $idzeraevenfecha
     * @return \Folha\Entities\MigEventoh
     */
    public function setIdzeraevenfecha ($idzeraevenfecha) {
        if (empty($idzeraevenfecha)) {
            $idzeraevenfecha = self::DEFAULT_ID_ZERAEVENTO;
        }
        $this->idzeraevenfecha = $idzeraevenfecha;
    }

    /**
     * @param $idmediaevenferi
     * @return \Folha\Entities\MigEventoh
     */
    public function setIdmediaevenferi ($idmediaevenferi) {
        if (empty($idmediaevenferi)) {
            $idmediaevenferi = self::DEFAULT_IDMEDIA_EVENTO;
        }
        $this->idmediaevenferi = $idmediaevenferi;
    }

    /**
     * @param $idfaltas13resc
     * @return \Folha\Entities\MigEventoh
     */
    public function setIdfaltas13resc ($idfaltas13resc) {
        if (empty($idfaltas13resc)) {
            $idfaltas13resc = self::DEFAULT_IDFALTA_13;
        }
        $this->idfaltas13resc = $idfaltas13resc;
    }

    /**
     * @param $nmeventoh
     * @throws \Exception
     * @return \Folha\Entities\MigEventoh
     */
    public function setNmeventoh ($nmeventoh) {
        if (empty($nmeventoh)) {
            throw new \Exception("Campo Obrigatório: 'Descrição'");
        }
        $this->nmeventoh = $nmeventoh;
    }

    /**
     * @param mixed $dtinclusao
     * @throws \Exception
     * @return \Folha\Entities\Base|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtultatu
     * @throws \Exception
     * @return \Folha\Entities\Base|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou em branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

    /**
     * @param mixed $dtmescompetenc
     * @throws \Exception
     * @return \Folha\Entities\Base|void
     */
    public function setDtmescompetenc($dtmescompetenc)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtmescompetenc)) {
            throw new \Exception("Campo Obrigatório: Data de Competência '$dtmescompetenc' com formato inválido ou em branco.");
        }

        if (!($dtmescompetenc instanceof \DateTime)) {
            $dtmescompetenc = DateUtil::getDataDeString($dtmescompetenc);
        }

        $this->dtmescompetenc = $dtmescompetenc;
    }

}