/* Tabela CUSTOPROCIA: CUSTOPROCIA */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CUSTOPROCIA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela CUSTOPROCIA,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_COC_CUSTOPROCIA
AFTER DELETE OR INSERT OR UPDATE
ON CUSTOPROCIA FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(60);
  V_DESC       VARCHAR2(500);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN      
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL;
      END IF;
      
      IF :OLD.CDPRODUTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdProduto=' || :OLD.CDPRODUTO;
      END IF;
      
      IF :OLD.CDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdCia=' || :OLD.CDCIA;
      END IF;
      
      IF :OLD.CDSEQCUSPC IS NOT NULL THEN
         V_DESC := V_DESC || ' CdSeqCusPc=' || :OLD.CDSEQCUSPC;
      END IF;
      
      IF :OLD.CDSEQITEMCP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdSeqItemCp=' || :OLD.CDSEQITEMCP;
      END IF;
      
        IF :OLD.DTHRGERPCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtHrGerpCia=' || :OLD.DTHRGERPCIA;
      END IF;
      
      IF :OLD.QTCUSPROCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' QtCusproCia=' || :OLD.QTCUSPROCIA;
      END IF;
      
      IF :OLD.DTCUSPROCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtCusProCia=' || :OLD.DTCUSPROCIA;
      END IF;
      
      IF :OLD.VRULLIQPRCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrUlLiqPrCia=' || :OLD.VRULLIQPRCIA;
      END IF;
      
      IF :OLD.VRULBRUPRCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrUlBruPrCia=' || :OLD.VRULBRUPRCIA;
      END IF;
      
      IF :OLD.VRMELIQPRCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrMeLiqPrCia=' || :OLD.VRMELIQPRCIA;
      END IF;
      
      IF :OLD.CDOPERPCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdOperPCia=' || :OLD.CDOPERPCIA;
      END IF;
      
      IF :OLD.VRUCLSAPPCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrUclSapPCia=' || :OLD.VRUCLSAPPCIA;
      END IF;
           
      IF :OLD.VRUCBSAPPCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrUcbSapPCia=' || :OLD.VRUCBSAPPCIA;
      END IF;
      
      IF :OLD.VRMELSAPPCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrMelSapPCia=' || :OLD.VRMELSAPPCIA;
      END IF;
      
      IF :OLD.VRMEBSAPPCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrMebSapPCia=' || :OLD.VRMEBSAPPCIA;
      END IF;
      
      IF :OLD.VRMEBRUPRCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrMebRuPrCia=' || :OLD.VRMEBRUPRCIA;
      END IF;
      
      IF :OLD.QTAPROVPCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' QtAprovPCia=' || :OLD.QTAPROVPCIA;
      END IF;
      
      IF :OLD.CDRECPRIPC IS NOT NULL THEN
         V_DESC := V_DESC || ' CdRecPriPc=' || :OLD.CDRECPRIPC;
      END IF;
      
      IF :OLD.CDSUBGRU IS NOT NULL THEN
         V_DESC := V_DESC || ' CdSubGru=' || :OLD.CDSUBGRU;
      END IF;
      
      IF :OLD.CDSERVICO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdServico=' || :OLD.CDSERVICO;
      END IF;
      
      IF :OLD.CDMANCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdMancia=' || :OLD.CDMANCIA;
      END IF;
      
      IF :OLD.IDTPMANUAL IS NOT NULL THEN
         V_DESC := V_DESC || ' IdTpManual=' || :OLD.IDTPMANUAL;
      END IF;
      
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDPRODUTO || '|' || :OLD.CDCIA || '|' || :OLD.CDSEQCUSPC || '|' || :OLD.CDSEQITEMCP;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL        <> :NEW.CDFILIAL   )OR
            (:OLD.CDPRODUTO       <> :NEW.CDPRODUTO  )OR
            (:OLD.CDCIA           <> :NEW.CDCIA      )OR
            (:OLD.CDSEQCUSPC      <> :NEW.CDSEQCUSPC )OR
            (:OLD.CDSEQITEMCP     <> :NEW.CDSEQITEMCP)OR
            (:OLD.DTHRGERPCIA     <> :NEW.DTHRGERPCIA)OR
            (NVL(:OLD.QTCUSPROCIA, 0)       <> NVL(:NEW.QTCUSPROCIA, 0))  OR
            (NVL(:OLD.DTCUSPROCIA, SYSDATE) <> NVL(:NEW.DTCUSPROCIA, SYSDATE)) OR
            (NVL(:OLD.VRULLIQPRCIA, 0)      <> NVL(:NEW.VRULLIQPRCIA, 0)) OR
            (NVL(:OLD.VRULBRUPRCIA, 0)      <> NVL(:NEW.VRULBRUPRCIA, 0)) OR
            (NVL(:OLD.VRMELIQPRCIA, 0)      <> NVL(:NEW.VRMELIQPRCIA, 0)) OR
            (NVL(:OLD.CDOPERPCIA, ' ')       <> NVL(:NEW.CDOPERPCIA, ' '))  OR
            (NVL(:OLD.VRUCLSAPPCIA, 0)      <> NVL(:NEW.VRUCLSAPPCIA, 0)) OR
            (NVL(:OLD.VRUCBSAPPCIA, 0)      <> NVL(:NEW.VRUCBSAPPCIA, 0)) OR
            (NVL(:OLD.VRMELSAPPCIA, 0)      <> NVL(:NEW.VRMELSAPPCIA, 0)) OR
            (NVL(:OLD.VRMEBSAPPCIA, 0)      <> NVL(:NEW.VRMEBSAPPCIA, 0)) OR
            (NVL(:OLD.VRMEBRUPRCIA, 0)      <> NVL(:NEW.VRMEBRUPRCIA, 0)) OR
            (NVL(:OLD.QTAPROVPCIA, 0)       <> NVL(:NEW.QTAPROVPCIA, 0))  OR
            (NVL(:OLD.CDRECPRIPC, ' ')       <> NVL(:NEW.CDRECPRIPC, ' '))  OR
            (NVL(:OLD.CDSUBGRU, ' ')         <> NVL(:NEW.CDSUBGRU, ' '))    OR
            (NVL(:OLD.CDSERVICO, ' ')        <> NVL(:NEW.CDSERVICO, ' '))   OR
            (NVL(:OLD.CDMANCIA, ' ')         <> NVL(:NEW.CDMANCIA, ' '))    OR
            (NVL(:OLD.IDTPMANUAL, ' ')       <> NVL(:NEW.IDTPMANUAL, ' '))  THEN
             
            IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
               V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
            END IF;
            
            IF NVL(:OLD.CDPRODUTO, ' ') <> NVL(:NEW.CDPRODUTO, ' ') THEN
               V_DESC := V_DESC || ' CdProduto=' || :OLD.CDPRODUTO || '|' || :NEW.CDPRODUTO;
            END IF;
            
            IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
               V_DESC := V_DESC || ' CdCia=' || :OLD.CDCIA || '|' || :NEW.CDCIA;
            END IF;
            
            IF NVL(:OLD.CDSEQCUSPC, ' ') <> NVL(:NEW.CDSEQCUSPC, ' ') THEN
               V_DESC := V_DESC || ' CdSeqCusPc=' || :OLD.CDSEQCUSPC || '|' || :NEW.CDSEQCUSPC;
            END IF;
            
            IF NVL(:OLD.CDSEQITEMCP, ' ') <> NVL(:NEW.CDSEQITEMCP, ' ') THEN
               V_DESC := V_DESC || ' CdSeqItemCp=' || :OLD.CDSEQITEMCP || '|' || :NEW.CDSEQITEMCP;
            END IF;
            
            IF NVL(:OLD.DTHRGERPCIA, SYSDATE) <> NVL(:NEW.DTHRGERPCIA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtHrGerPCia=' || :OLD.DTHRGERPCIA || '|' || :NEW.DTHRGERPCIA;
            END IF;
            
            IF NVL(:OLD.QTCUSPROCIA, 0) <> NVL(:NEW.QTCUSPROCIA, 0) THEN
               V_DESC := V_DESC || ' QtCusProCia=' || :OLD.QTCUSPROCIA || '|' || :NEW.QTCUSPROCIA;
            END IF;
            
            IF NVL(:OLD.DTCUSPROCIA, SYSDATE) <> NVL(:NEW.DTCUSPROCIA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtCusProCia=' || :OLD.DTCUSPROCIA || '|' || :NEW.DTCUSPROCIA;
            END IF;
            
            IF NVL(:OLD.VRULLIQPRCIA, 0) <> NVL(:NEW.VRULLIQPRCIA, 0) THEN
               V_DESC := V_DESC || ' VrUlLiqPrCia=' || :OLD.VRULLIQPRCIA || '|' || :NEW.VRULLIQPRCIA;
            END IF;
            
            IF NVL(:OLD.VRULBRUPRCIA, 0) <> NVL(:NEW.VRULBRUPRCIA, 0) THEN
               V_DESC := V_DESC || ' VrUlBruPrCia=' || :OLD.VRULBRUPRCIA || '|' || :NEW.VRULBRUPRCIA;
            END IF;
            
            IF NVL(:OLD.VRMELIQPRCIA, 0) <> NVL(:NEW.VRMELIQPRCIA, 0) THEN
               V_DESC := V_DESC || ' VrMeLiqPrCia=' || :OLD.VRMELIQPRCIA || '|' || :NEW.VRMELIQPRCIA;
            END IF;
            
            IF NVL(:OLD.CDOPERPCIA, ' ') <> NVL(:NEW.CDOPERPCIA, ' ') THEN
               V_DESC := V_DESC || ' CdOperPCia=' || :OLD.CDOPERPCIA || '|' || :NEW.CDOPERPCIA;
            END IF;
            
            IF NVL(:OLD.VRUCLSAPPCIA, 0) <> NVL(:NEW.VRUCLSAPPCIA, 0) THEN
               V_DESC := V_DESC || ' VrUclSapPCia=' || :OLD.VRUCLSAPPCIA || '|' || :NEW.VRUCLSAPPCIA;
            END IF;
                        
            IF NVL(:OLD.VRUCBSAPPCIA, 0) <> NVL(:NEW.VRUCBSAPPCIA, 0) THEN
               V_DESC := V_DESC || ' VrUcbSapPCia=' || :OLD.VRUCBSAPPCIA || '|' || :NEW.VRUCBSAPPCIA;
            END IF;
            
            IF NVL(:OLD.VRMELSAPPCIA, 0) <> NVL(:NEW.VRMELSAPPCIA, 0) THEN
               V_DESC := V_DESC || ' VrMelSappCia=' || :OLD.VRMELSAPPCIA || '|' || :NEW.VRMELSAPPCIA;
            END IF;
            
            IF NVL(:OLD.VRMEBSAPPCIA, 0) <> NVL(:NEW.VRMEBSAPPCIA, 0) THEN
               V_DESC := V_DESC || ' VrMebSapPCia=' || :OLD.VRMEBSAPPCIA || '|' || :NEW.VRMEBSAPPCIA;
            END IF;
            
            IF NVL(:OLD.VRMEBRUPRCIA, 0) <> NVL(:NEW.VRMEBRUPRCIA, 0) THEN
               V_DESC := V_DESC || ' VrMeBruPrCia=' || :OLD.VRMEBRUPRCIA || '|' || :NEW.VRMEBRUPRCIA;
            END IF;
            
            IF NVL(:OLD.QTAPROVPCIA, 0) <> NVL(:NEW.QTAPROVPCIA, 0) THEN
               V_DESC := V_DESC || ' QtAprovPCia=' || :OLD.QTAPROVPCIA || '|' || :NEW.QTAPROVPCIA;
            END IF;
            
            IF NVL(:OLD.CDRECPRIPC, ' ') <> NVL(:NEW.CDRECPRIPC, ' ') THEN
               V_DESC := V_DESC || ' CdRecPriPc=' || :OLD.CDRECPRIPC || '|' || :NEW.CDRECPRIPC;
            END IF;
            
            IF NVL(:OLD.CDSUBGRU, ' ') <> NVL(:NEW.CDSUBGRU, ' ') THEN
               V_DESC := V_DESC || ' CdSubGru=' || :OLD.CDSUBGRU || '|' || :NEW.CDSUBGRU;
            END IF;
            
            IF NVL(:OLD.CDSERVICO, ' ') <> NVL(:NEW.CDSERVICO, ' ') THEN
               V_DESC := V_DESC || ' CdServico=' || :OLD.CDSERVICO || '|' || :NEW.CDSERVICO;
            END IF;
            
            IF NVL(:OLD.CDMANCIA, ' ') <> NVL(:NEW.CDMANCIA, ' ') THEN
               V_DESC := V_DESC || ' CdMancia=' || :OLD.CDMANCIA || '|' || :NEW.CDMANCIA;
            END IF;
            
            IF NVL(:OLD.IDTPMANUAL, ' ') <> NVL(:NEW.IDTPMANUAL, ' ') THEN
               V_DESC := V_DESC || ' IdTpManual=' || :OLD.IDTPMANUAL || '|' || :NEW.IDTPMANUAL;
            END IF;
                                     
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDPRODUTO || '|' || :OLD.CDCIA || '|' || :OLD.CDSEQCUSPC || '|' || :OLD.CDSEQITEMCP;
         END IF;
      ELSE
         IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
            V_DESC := V_DESC || 'CdFilial=' || :NEW.CDFILIAL;
         END IF;
         
         IF NVL(:OLD.CDPRODUTO, ' ') <> NVL(:NEW.CDPRODUTO, ' ') THEN
            V_DESC := V_DESC || ' CdProduto=' || :NEW.CDPRODUTO;
         END IF;
         
         IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
            V_DESC := V_DESC || ' CdCia=' || :NEW.CDCIA;
         END IF;
         
         IF NVL(:OLD.CDSEQCUSPC, ' ') <> NVL(:NEW.CDSEQCUSPC, ' ') THEN
            V_DESC := V_DESC || ' CdSeqCusPc=' || :NEW.CDSEQCUSPC;
         END IF;
         
         IF NVL(:OLD.CDSEQITEMCP, ' ') <> NVL(:NEW.CDSEQITEMCP, ' ') THEN
            V_DESC := V_DESC || ' CdSeqItemCp=' || :NEW.CDSEQITEMCP;
         END IF;
         
         IF NVL(:OLD.DTHRGERPCIA, SYSDATE) <> NVL(:NEW.DTHRGERPCIA, SYSDATE) THEN
            V_DESC := V_DESC || ' DtHrGerPCia=' || :NEW.DTHRGERPCIA;
         END IF;
         
         IF NVL(:OLD.QTCUSPROCIA, 0) <> NVL(:NEW.QTCUSPROCIA, 0) THEN
            V_DESC := V_DESC || ' QtCusProCia=' || :NEW.QTCUSPROCIA;
         END IF;
         
         IF NVL(:OLD.DTCUSPROCIA, SYSDATE) <> NVL(:NEW.DTCUSPROCIA, SYSDATE) THEN
            V_DESC := V_DESC || ' DtCusProCia=' || :NEW.DTCUSPROCIA;
         END IF;
         
         IF NVL(:OLD.VRULLIQPRCIA, 0) <> NVL(:NEW.VRULLIQPRCIA, 0) THEN
            V_DESC := V_DESC || ' VrUlLiqPrCia=' || :NEW.VRULLIQPRCIA;
         END IF;
         
         IF NVL(:OLD.VRULBRUPRCIA, 0) <> NVL(:NEW.VRULBRUPRCIA, 0) THEN
            V_DESC := V_DESC || ' VrUlBruPrCia=' || :NEW.VRULBRUPRCIA;
         END IF;
         
         IF NVL(:OLD.VRMELIQPRCIA, 0) <> NVL(:NEW.VRMELIQPRCIA, 0) THEN
            V_DESC := V_DESC || ' VrMeLiqPrCia=' || :NEW.VRMELIQPRCIA;
         END IF;
         
         IF NVL(:OLD.CDOPERPCIA, ' ') <> NVL(:NEW.CDOPERPCIA, ' ') THEN
            V_DESC := V_DESC || ' CdOperPCia=' || :NEW.CDOPERPCIA;
         END IF;
         
         IF NVL(:OLD.VRUCLSAPPCIA, 0) <> NVL(:NEW.VRUCLSAPPCIA, 0) THEN
            V_DESC := V_DESC || ' VrUclSapPCia=' || :NEW.VRUCLSAPPCIA;
         END IF;
                
         IF NVL(:OLD.VRUCBSAPPCIA, 0) <> NVL(:NEW.VRUCBSAPPCIA, 0) THEN
            V_DESC := V_DESC || ' VrUcbSapPCia=' || :NEW.VRUCBSAPPCIA;
         END IF;
         
         IF NVL(:OLD.VRMELSAPPCIA, 0) <> NVL(:NEW.VRMELSAPPCIA, 0) THEN
            V_DESC := V_DESC || ' VrMelSapPCia=' || :NEW.VRMELSAPPCIA;
         END IF;
         
         IF NVL(:OLD.VRMEBSAPPCIA, 0) <> NVL(:NEW.VRMEBSAPPCIA, 0) THEN
            V_DESC := V_DESC || ' VrMebSapPCia=' || :NEW.VRMEBSAPPCIA;
         END IF;
         
         IF NVL(:OLD.VRMEBRUPRCIA, 0) <> NVL(:NEW.VRMEBRUPRCIA, 0) THEN
            V_DESC := V_DESC || ' VrMeBruPrCia=' || :NEW.VRMEBRUPRCIA;
         END IF;
         
         IF NVL(:OLD.QTAPROVPCIA, 0) <> NVL(:NEW.QTAPROVPCIA, 0) THEN
            V_DESC := V_DESC || ' QtAprovPCia=' || :NEW.QTAPROVPCIA;
         END IF;
         
         IF NVL(:OLD.CDRECPRIPC, ' ') <> NVL(:NEW.CDRECPRIPC, ' ') THEN
            V_DESC := V_DESC || ' CdRecPriPc=' || :NEW.CDRECPRIPC;
         END IF;
         
         IF NVL(:OLD.CDSUBGRU, ' ') <> NVL(:NEW.CDSUBGRU, ' ') THEN
            V_DESC := V_DESC || ' CdSubGru=' || :NEW.CDSUBGRU;
         END IF;
         
         IF NVL(:OLD.CDSERVICO, ' ') <> NVL(:NEW.CDSERVICO, ' ') THEN
            V_DESC := V_DESC || ' CdServico=' || :NEW.CDSERVICO;
         END IF;
         
         IF NVL(:OLD.CDMANCIA, ' ') <> NVL(:NEW.CDMANCIA, ' ') THEN
            V_DESC := V_DESC || ' CdMancia=' || :NEW.CDMANCIA;
         END IF;
         
         IF NVL(:OLD.IDTPMANUAL, ' ') <> NVL(:NEW.IDTPMANUAL, ' ') THEN
            V_DESC := V_DESC || ' IdTpManual=' || :NEW.IDTPMANUAL;
         END IF;
              
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL || '|' || :NEW.CDPRODUTO || '|' || :NEW.CDCIA || '|' || :NEW.CDSEQCUSPC || '|' || :NEW.CDSEQITEMCP;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('CUSTOPROCIA', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_COC_CUSTOPROCIA','5.85.xxx'); END;
/

